 -- Load the OBS API module
obs = obslua

-- ******* IMPORTANT:: UPDATE TO YOUR PATH!!! *******
local json_file_path = "PATH/TO/YOUR/JSON/FILE.JSON"

function checkScoreUpdate()
    -- Create an OBS data object from the JSON file
    local data = obs.obs_data_create_from_json_file(json_file_path)

    -- Get the data for player 1 from the JSON data object
    local scoreboard = obs.obs_data_get_obj(data, "scoreboard")
    local player_1_data = obs.obs_data_get_obj(scoreboard, "player_1")
    local player_2_data = obs.obs_data_get_obj(scoreboard, "player_2")

    local player_1_name = obs.obs_data_get_string(player_1_data, "name")
    local player_2_name = obs.obs_data_get_string(player_2_data, "name")

    local player_1_score = obs.obs_data_get_string(player_1_data, "score")
    local player_2_score = obs.obs_data_get_string(player_2_data, "score")

    -- Release now that we have the name
    obs.obs_data_release(scoreboard)
    obs.obs_data_release(player_1_data)
    obs.obs_data_release(player_2_data)

    -- Grab the Name Sources
    local player_1_name_source = obs.obs_get_source_by_name("Player 1")
    local player_2_name_source = obs.obs_get_source_by_name("Player 2")

    -- Grab the Score Sources
    local player_1_score_source = obs.obs_get_source_by_name("Player 1 - Score")
    local player_2_score_source = obs.obs_get_source_by_name("Player 2 - Score")

    -- Set the Names

    -- Player 1
    local settings = obs.obs_data_create()
    obs.obs_data_set_string(settings, "text", player_1_name)
    obs.obs_source_update(player_1_name_source, settings)
    obs.obs_data_release(settings)

    -- Player 2
    local settings = obs.obs_data_create()
    obs.obs_data_set_string(settings, "text", player_2_name)
    obs.obs_source_update(player_2_name_source, settings)
    obs.obs_data_release(settings)

    -- Set the Scores

    -- Player 1
    local settings = obs.obs_data_create()
    obs.obs_data_set_string(settings, "text", player_1_score)
    obs.obs_source_update(player_1_score_source, settings)
    obs.obs_data_release(settings)

    -- Player 2
    local settings = obs.obs_data_create()
    obs.obs_data_set_string(settings, "text", player_2_score)
    obs.obs_source_update(player_2_score_source, settings)
    obs.obs_data_release(settings)

    -- Release the references to the text sources
    obs.obs_source_release(player_1_name_source)
    obs.obs_source_release(player_2_name_source)
    obs.obs_source_release(player_1_score_source)
    obs.obs_source_release(player_2_score_source)

end

function script_tick(seconds)
    checkScoreUpdate()
end

function script_load(settings)
    obs.timer_add(script_tick, 3000)
end